﻿
;   Security Access Tuner Simulator - Version 1.6
;      by dcruze (dcruzefaq@gmail.com)

#NoEnv  ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input  ; Recommended for new scripts due to its superior speed and reliability.
SetWorkingDir %A_ScriptDir%  ; Ensures a consistent starting directory.
#MaxThreads 50
#Include data\Class_CTLCOLORS.ahk
#Include, data\Gdip_All.ahk

;ResRead( WAV_Beep, "sfx\beep.wav" )
ResRead( WAV_Cursor, "sfx\cursor.wav" )
;ResRead( WAV_Fail, "sfx\fail.wav" )
;ResRead( WAV_Punch, "sfx\punch.wav" )
;ResRead( WAV_Success, "sfx\success.wav" )
;ResRead( WAV_Success2, "sfx\success2.wav" )

Col   := "f0f0f0"

filePath = data\score.sav

IfNotExist, %filePath%
{
FileAppend,
( 
25000
0
0
25000
0
0
25000
0
0
), %filePath%
}

FileReadLine, Best1, %filePath%, 1
FileReadLine, Attempt1, %filePath%, 2
FileReadLine, Average1, %filePath%, 3
FileReadLine, Best2, %filePath%, 4
FileReadLine, Attempt2, %filePath%, 5
FileReadLine, Average2, %filePath%, 6
FileReadLine, Best3, %filePath%, 7
FileReadLine, Attempt3, %filePath%, 8
FileReadLine, Average3, %filePath%, 9

; Start gdi+
If !pToken := Gdip_Startup()
{
	MsgBox, 48, gdiplus error!, Gdiplus failed to start. Please ensure you have gdiplus on your system
	ExitApp
}

y1 = 527
y2 := y1 - 5

; cursor
XPos = 9
YPos = 310

YPos2 = 83

CPos = 1
Sound = 1
Level = 1
Amount = 3
TimeLimit = 20000

BeepFile := "sfx\beep.mp3"
NoiseFile := "sfx\noise.mp3"

mciSendString("open " """" NoiseFile """" " type mpegvideo Alias MyNoise")
mciSendString("seek MyNoise to start")
mciSendString("play MyNoise repeat")

Gui, Color, 336633

Gui, Add, Checkbox, y%y1% x138 Checked vSound gSound HwndHCheckbox1, Sound
Gui, Add, Checkbox, y%y1% vBlindCheck gBlindCheck HwndHCheckbox2, Blind
Gui, Add, Radio, y%y1% vLevel gLevel checked HwndHRadio1, Level 1
Gui, Add, Radio, y%y1% gLevel HwndHRadio2, Level 2
Gui, Add, Radio, y%y1% gLevel HwndHRadio3, Level 3
Gui, Add, Button, y%y2% gButtonRestart vbtnDown, &Restart

CTLCOLORS.Attach(HCheckbox1, Col, "")
CTLCOLORS.Attach(HCheckbox2, Col, "")
CTLCOLORS.Attach(HRadio1, Col, "")
CTLCOLORS.Attach(HRadio2, Col, "")
CTLCOLORS.Attach(HRadio3, Col, "")

Gui, Add, Picture, x0 y0 0x4000000, gfx\bg.png
Gui, Add, Picture, x11 y312 vBlind, gfx\blind.png

ScoreBoard()

Instructions =
(
WASD and arrow keys moves the cursor
E, Space, Enter and Mouse Wheel enters code
)

Gui Font, s39 q3, Jixellation
Gui, Add, Text, vTimerText c999999 x210 y250 BackgroundTrans, 00:00:00
Gui, Add, Text, vMiscText1 c999999 x128 y250 BackgroundTrans, CODE ACCEPTED
Gui, Add, Text, vMiscText2 c999999 x119 y250 BackgroundTrans, INCORRECT CODE
Gui, Add, Text, vMiscText3 c999999 x137 y250 BackgroundTrans, ACCESS DENIED
Gui Font, s20 q3, Jixellation
Gui, Add, Text, vTimerTextSm c999999 x-262 y227 BackgroundTrans, 00:00:00

Gui Font, s18 q3 bold, Courier New
Gui, Add, Text, vScoreBoardText c999900 x117 y86 BackgroundTrans,%ScoreBoard%

Gui Font, s18 q3 normal, Jixellation
Gui, Add, Text, vInstructionText c999900 x65 y237 BackgroundTrans, %Instructions%

GuiControl, Hide, TimerText
GuiControl, Hide, MiscText1
GuiControl, Hide, MiscText2
GuiControl, Hide, MiscText3
GuiControl, Hide, TimerTextSm

Gui, Add, Picture, x0 y230 w640 h20 0xE vProgressBar
GuiControl, Hide, ProgressBar

Gui, Add, Picture, vSymbol1, gfx\symbol1.png
Gui, Add, Picture, vSymbol2, gfx\symbol2.png
Gui, Add, Picture, vSymbol3, gfx\symbol3.png
Gui, Add, Picture, vSymbol4, gfx\symbol4.png
Gui, Add, Picture, vSymbol5, gfx\symbol5.png
Gui, Add, Picture, vSymbol6, gfx\symbol6.png
Gui, Add, Picture, vSymbol7, gfx\symbol7.png
Gui, Add, Picture, vSymbol8, gfx\symbol8.png

Gui, Add, Picture, vWarning x11 y258 BackgroundTrans, gfx\warning.png

GuiControl, Hide, Blind
GuiControl, Hide, Symbol1
GuiControl, Hide, Symbol2
GuiControl, Hide, Symbol3
GuiControl, Hide, Symbol4
GuiControl, Hide, Symbol5
GuiControl, Hide, Symbol6
GuiControl, Hide, Symbol7
GuiControl, Hide, Symbol8

GuiControl, Hide, Warning

Gui, Add, Picture, x%XPos% y%YPos% BackgroundTrans vCursor, gfx\cursor.png

Gui, Show, W640 H550, Security Access Tuner Simulator - Version 1.6
Gui, Submit, NoHide

#Persistent
SetTimer, CheckTimer, 20

return

; ------------------------------------------------------------------------------

mciSendString(Command)
{
   Return, DllCall("winmm.dll\mciSendString", Str,Command, Str,"", Int,0, Int,0)
}

; ------------------------------------------------------------------------------
 
PlaySoundAsync( ByRef Sound )
{
   Return DllCall( "winmm.dll\PlaySound" ( A_IsUnicode ? "W" : "A" ), UInt,&Sound, UInt,0, UInt, 0x7 )
}

; ------------------------------------------------------------------------------
 
ResRead( ByRef Var, Key )
{ 
   VarSetCapacity( Var, 128 ), VarSetCapacity( Var, 0 )
   If ! ( A_IsCompiled )
   {
      FileGetSize, nSize, %Key%
      FileRead, Var, *c %Key%
      Return nSize
   }
 
   If hMod := DllCall( "GetModuleHandle", UInt,0 )
      If hRes := DllCall( "FindResource", UInt,hMod, Str,Key, UInt,10 )
         If hData := DllCall( "LoadResource", UInt,hMod, UInt,hRes )
            If pData := DllCall( "LockResource", UInt,hData )
               Return VarSetCapacity( Var, nSize := DllCall( "SizeofResource", UInt,hMod, UInt,hRes ) )
                , DllCall( "RtlMoveMemory", Str,Var, UInt,pData, UInt,nSize )
   Return 0    
}

; ------------------------------------------------------------------------------

GuiClose:

FileDelete, %filePath%
FileAppend,
( 
%Best1%
%Attempt1%
%Average1%
%Best2%
%Attempt2%
%Average2%
%Best3%
%Attempt3%
%Average3%
), %filePath%

Sleep 100

CTLCOLORS.Free()
Gdip_Shutdown(pToken)

ExitApp

; ------------------------------------------------------------------------------

GuiSize:
   If (A_EventInfo != 1)
   {
      Gui, %A_Gui%:+LastFound
      WinSet, ReDraw
   }
Return

; ------------------------------------------------------------------------------

CheckScore()
{
   global

   if(TimeSpent < Best%Level% )
   {
      Best%Level% := TimeSpent
      NewHighScore = 1
   }

   Attempt%Level% ++
   Average%Level% += TimeSpent   
   
   return
}

; ------------------------------------------------------------------------------

ScoreBoard()
{
   global

   Space := " "

   S1 := "Level    Best Time    Average`n"

   NewTimer = %Best1%
   TimeString()
   TBest1 := "  " . TimeString . "  "

   if(Best1 = 25000) 
      TBest1 := "   N/A   "

   if(Attempt1 > 0)
   {
      NewTimer := Round( Average1 / Attempt1 )
      TimeString()
      TAverage1 := " " . TimeString . " "
   }

   if(Attempt1 = 0)
      TAverage1 := "  N/A  "


   NewTimer = %Best2%
   TimeString()
   TBest2 := "  " . TimeString . "  "

   if(Best2 = 25000) 
      TBest2 := "   N/A   "

   if(Attempt2 > 0)
   {
      NewTimer := Round( Average2 / Attempt2 )
      TimeString()
      TAverage2 := " " . TimeString . " "
   }

   if(Attempt2 = 0)
      TAverage2 := "  N/A  "


   NewTimer = %Best3%
   TimeString()
   TBest3 := "  " . TimeString . "  "

   if(Best3 = 25000) 
      TBest3 := "   N/A   "

   if(Attempt3 > 0)
   {
      NewTimer := Round( Average3 / Attempt3 )
      TimeString()
      TAverage3 := " " . TimeString . " "
   }

   if(Attempt3 = 0)
      TAverage3 := "  N/A  "

   S2 := "  1      " . TBest1 . "    " . TAverage1 . "`n"
   S3 := "  2      " . TBest2 . "    " . TAverage2 . "`n"
   S4 := "  3      " . TBest3 . "    " . TAverage3 . "`n"

   ScoreBoard = %S1%%S2%%S3%%S4%

   return
}

; ------------------------------------------------------------------------------

TimeString()
{
   global
   
   StringLen, tl, NewTimer

   if(tl = 5)
   {
      StringTrimRight, secs, NewTimer, 3
      StringMid, csecs, NewTimer, 3, 2
   }

   if(tl = 4)
   {
      StringTrimRight, secs, NewTimer, 3
      StringMid, csecs, NewTimer, 2, 2
      secs = 0%secs%
   }

   if(tl = 3)
   {
      secs = 00
      StringTrimRight, csecs, NewTimer, 1
   }

   if(tl = 2)
   {
      secs = 00
      StringTrimLeft, csecs, NewTimer, 1
      csecs = 0%csecs%
   }

   if(tl = 1)
   {
      secs = 00
      csecs = 00
   }

   TimeString = %secs%:%csecs%
}

; ------------------------------------------------------------------------------

Resolve(Scenario)
{
   global

   if(resolved)
      return

   resolved = 1
   active = 0

   GuiControl, Hide, TimerText

   if(Sound = 1 )
      mciSendString("stop MyBeep")

   ; WIN

   if(scenario = 1) ; WIN
   {
      GuiControl, Show, MiscText1
      GuiControl, Move, TimerTextSm, x262 y227
      GuiControl, Show, TimerTextSm

      NewHighScore = 0

      CheckScore()
      ScoreBoard()

      Gosub, ControlOn

      if(Sound = 1 )
      {
         SoundPlay, sfx\punch.wav, 1

         if(NewHighScore = 1)
            SoundPlay, sfx\success2.wav
         else
            SoundPlay, sfx\success.wav
      }
   }


   ; FAIL

   if(scenario = 2) ; FAIL
   {
      Gosub, ControlOn

      if(Sound = 1 )
      {
	       SoundPlay, sfx\punch.wav, 1
         SoundPlay, sfx\fail.wav
      }

      GuiControl, Show, MiscText2

   }


   ; TIMEOUT

   if(scenario = 3) ; TIMEOUT
   {
      Gosub, ControlOn

      if(Sound = 1 )
         SoundPlay, sfx\fail.wav

      GuiControl, Show, MiscText3
   }


   if(Sound = 1 )
   {
      mciSendString("seek MyNoise to start")
      mciSendString("play MyNoise repeat")
   }

   return
}

; ------------------------------------------------------------------------------

CheckTimer:

   if(active)
   {
      LtTickCount := A_TickCount - BiginTickCount
      NewTimer := TimeLimit - LtTickCount
      TimeSpent := TimeLimit - NewTimer

      if(NewTimer < 0)
      {
         Resolve(3)
         return
      }

      TimeString()

      TimerLeft = 00:%TimeString%

      GuiControl, -Redraw, TimerText
      GuiControl, -Redraw, TimerText2

      GuiControl,, TimerText, %TimerLeft%
      GuiControl,, TimerTextSm, %TimerLeft%

      GuiControl, +Redraw, TimerText
      GuiControl, +Redraw, TimerText2

      Percentage := 100 - (( TimeSpent / TimeLimit ) * 100)
      ProgressColor = 0xff66cc66

      if(Percentage < 50)
         ProgressColor = 0xffcccc66

      if(Percentage < 25)
      {
         if(!WarnCount)
         {
            WarnCount := A_TickCount
            GuiControl, Show, Warning
            ToggleWarning = 1
         }       

         WarnCount2 := A_TickCount - WarnCount

         if(WarnCount2 > 400)
         {
            if(ToggleWarning)
            {
               GuiControl, Hide, Warning
               ToggleWarning = 0
            }
            else           
            {
               GuiControl, Show, Warning
               ToggleWarning = 1
            }

            WarnCount := A_TickCount
         }

         ProgressColor = 0xffcc3333
      }

      Gdip_SetProgress(ProgressBar, Percentage, ProgressColor, 0xff336633)
   }

return

; ------------------------------------------------------------------------------

Gdip_SetProgress(ByRef Variable, Percentage, Foreground, Background=0x00000000)
{
   GuiControlGet, Pos, Pos, Variable
	 GuiControlGet, hwnd, hwnd, Variable

   pBrushFront := Gdip_BrushCreateSolid(Foreground), pBrushBack := Gdip_BrushCreateSolid(Background)
   pBitmap := Gdip_CreateBitmap(Posw, Posh), G := Gdip_GraphicsFromImage(pBitmap)

   WarnHeight := Posh-5

   if(Percentage < 50)
      WarnHeight := Posh

   Gdip_FillRectangle(G, pBrushFront, (100 - Percentage)*640/100/2, 0, (Posw)*(Percentage/100), WarnHeight)

   hBitmap := Gdip_CreateHBITMAPFromBitmap(pBitmap)
   SetImage(hwnd, hBitmap)
	
   Gdip_DeleteBrush(pBrushFront), Gdip_DeleteBrush(pBrushBack)
	 Gdip_DeleteGraphics(G), Gdip_DisposeImage(pBitmap), DeleteObject(hBitmap)
   Return, 0
}

; ------------------------------------------------------------------------------

Punch:

   if(!Active)
   {
      Gosub, ButtonRestart
      return
   }

   StringMid, temp, temp3, step, 1

   if(temp = cpos)
   {
      GuiControl, Hide, Symbol%temp%

      if(Sound = 1 )
         SoundPlay, sfx\punch.wav

      if(step = amount && active)
         Resolve(1)

      step++
      return
   }

   Resolve(3)

return	

; ------------------------------------------------------------------------------

ControlOn:

   WarnCount = 0
   ToggleWarning = 0
   Resolved = 0

   GuiControl, Hide, Warning

   GuiControl, Hide, Symbol1
   GuiControl, Hide, Symbol2
   GuiControl, Hide, Symbol3
   GuiControl, Hide, Symbol4
   GuiControl, Hide, Symbol5
   GuiControl, Hide, Symbol6
   GuiControl, Hide, Symbol7
   GuiControl, Hide, Symbol8

   GuiControl, Hide, ProgressBar

   GuiControl, Enable, Sound
   GuiControl, Enable, BlindCheck

   Loop, 3
      GuiControl, Enable, % HRadio%A_Index%

   GuiControl, Enable, btnDown

   GuiControl, Show, ScoreBoardText

   GuiControl, -Redraw, ScoreBoardText
   GuiControl,, ScoreBoardText, %ScoreBoard%
   GuiControl, +Redraw, ScoreBoardText

return

; ------------------------------------------------------------------------------

ButtonRestart:

   BiginTickCount=%A_TickCount%
   Active = 1

   GuiControl, Disable, Sound
   GuiControl, Disable, BlindCheck

   Loop, 3
      GuiControl, Disable, % HRadio%A_Index%

   GuiControl, disable, btnDown
   GuiControl, Hide, ScoreBoardText

   XPos = 9
   YPos = 310

   GuiControl, Hide, Cursor
   GuiControl, Move, Cursor, x%XPos% y%YPos%
   GuiControl, Show, Cursor

   CPos = 1

   GuiControl, Hide, Symbol1
   GuiControl, Hide, Symbol2
   GuiControl, Hide, Symbol3
   GuiControl, Hide, Symbol4
   GuiControl, Hide, Symbol5
   GuiControl, Hide, Symbol6
   GuiControl, Hide, Symbol7
   GuiControl, Hide, Symbol8

   GuiControl, Hide, MiscText1
   GuiControl, Hide, MiscText2
   GuiControl, Hide, MiscText3

   GuiControl, Hide, TimerTextSm
   GuiControl, Move, TimerTextSm, x-262 y227

   GuiControl, Hide, InstructionText
   GuiControl, Show, ProgressBar

   XPos2 := (640 - (Amount * 90)) / 2

   temp = 12345678
   temp3 = 
   Loop %Amount%
   {
      StringLen, length, temp
      Random, rand, 1, length

      StringMid, temp2, temp, rand, 1
      StringReplace, temp, temp, %temp2%,, All

      temp3 = %temp3%%temp2%
   }

   Loop, Parse, temp3
   {
      abc = %A_Loopfield%

      GuiControl, Move, Symbol%abc%, x%XPos2% y%YPos2%
      GuiControl, Show, Symbol%abc%

      XPos2 += 90
   }

   step = 1
   mciSendString("stop MyNoise")

   if(Sound = 1)
   {
      mciSendString("open " """" BeepFile """" " type mpegvideo Alias MyBeep")
      mciSendString("seek MyBeep to start")
      mciSendString("play MyBeep")
   }

return

; ------------------------------------------------------------------------------

Sound:
Gui, Submit, NoHide

   if(Sound = 0)
      mciSendString("stop MyNoise")
   else
   {
      mciSendString("seek MyNoise to start")
      mciSendString("play MyNoise repeat")
   }

return

; ------------------------------------------------------------------------------

BlindCheck:
Gui, Submit, NoHide

   if(BlindCheck = 1)
      GuiControl, Show, Blind
   else
      GuiControl, Hide, Blind

return

; ------------------------------------------------------------------------------

Level:

   Gui, Submit, NoHide

   if(Level = 1)
   {
      TimeLimit = 20000
      Amount = 3
   }

   if(Level = 2)
   {
      TimeLimit = 15000
      Amount = 4
   }

   if(Level = 3)
   {
      TimeLimit = 10000
      Amount = 5
   }

return

; ------------------------------------------------------------------------------

#IfWinActive Security Access Tuner
W::
Up::

   if(Moving)
      return

   Moving = 1

   NPos := CPos

   if(CPos > 4)
   {
      YPos -= 110
      NPos := CPos - 4
   }

   GuiControl, Hide, Cursor
   GuiControl, Move, Cursor, x%XPos% y%YPos%
   GuiControl, Show, Cursor

   if(Cpos != NPos && Sound = 1 )
   {
      PlaySoundAsync( WAV_Cursor )
   }

   CPos := NPos

   Moving = 0
	
return

; ------------------------------------------------------------------------------

A::
Left::

   if(Moving)
      return

   Moving = 1

   NPos := CPos

   if(CPos = 2)
   {
      XPos -= 160
      NPos = 1
   }

   if(CPos = 3)
   {
      XPos -= 161
      NPos = 2
   }

   if(CPos = 4)
   {
      XPos -= 160
      NPos = 3
   }

   if(CPos = 6)
   {
      XPos -= 160
      NPos = 5
   }

   if(CPos = 7)
   {
      XPos -= 161
      NPos = 6
   }

   if(CPos = 8)
   {
      XPos -= 160
      NPos = 7
   }

   GuiControl, Hide, Cursor
   GuiControl, Move, Cursor, x%XPos% y%YPos%
   GuiControl, Show, Cursor

   if(Cpos != NPos && Sound = 1 )
      PlaySoundAsync( WAV_Cursor )

   CPos := NPos
   Moving = 0
	
return

; ------------------------------------------------------------------------------

S::
Down::

   if(Moving)
      return

   Moving = 1

   NPos := CPos

   if(CPos < 5)
   {
      YPos += 110
      NPos := CPos + 4
   }

   GuiControl, Hide, Cursor
   GuiControl, Move, Cursor, x%XPos% y%YPos%
   GuiControl, Show, Cursor

   if(Cpos != NPos && Sound = 1 )
      PlaySoundAsync( WAV_Cursor )

   CPos := NPos
   Moving = 0
	
return

; ------------------------------------------------------------------------------

D::
Right::

   if(Moving)
      return

   Moving = 1

   NPos := CPos

   if(CPos = 1)
   {
      XPos += 160
      NPos = 2
   }

   if(CPos = 2)
   {
      XPos += 161
      NPos = 3
   }

   if(CPos = 3)
   {
      XPos += 160
      NPos = 4
   }

   if(CPos = 5)
   {
      XPos += 160
      NPos = 6
   }

   if(CPos = 6)
   {
      XPos += 161
      NPos = 7
   }

   if(CPos = 7)
   {
      XPos += 160
      NPos = 8
   }

   GuiControl, Hide, Cursor
   GuiControl, Move, Cursor, x%XPos% y%YPos%
   GuiControl, Show, Cursor

   if(Cpos != NPos && Sound = 1 )
      PlaySoundAsync( WAV_Cursor )

   CPos := NPos
   Moving = 0
	
return

; ------------------------------------------------------------------------------

Space::
Enter::
WheelUp::
WheelDown::
E::

   Gosub, Punch

return
